      SUBROUTINE SF67R(X10,R10,T10)
         REAL R10,T10,X10
         COMMON /SF67R2/X0
         INTEGER C,IERR,J,L,L1,L2,M,N
         REAL A,A0,A1,A2,ALOG,ARGI,ARGR,ATAN,B,B0,C0,C1,C2,COS,E,EPS,
     1        EXP,F0,FI,G,G0,H0,PI,R0,RINT1,RINT2,S1,S2,SF67R1,SIN,
     2        SQRT,SYS001,T,T0,T1,T2,U,V,X0
         DIMENSION A(17),B(17),C(17,17),G(17)
         EQUIVALENCE (SYS001,PI)
         DATA SYS001/3.1415926535897/,EPS1/1.E-7/,EPS2/1.E-5/
       X0 = X10
       R0 = R10
       IF (X0 .GE. 2.5 .AND. R0 .LE. 0.5 .OR. X0 .GE. 3.5 .AND.
     1    R0 .LE. 1.5 .OR. X0 .GE. 4.5 .AND. R0 .LE. 2.0 .OR. X0 .GE.
     2    5.5 .AND. R0 .LE. 3.25 .OR. X0 .GE. 7.0 .AND. R0 .LE. 4.2)
     3  GO TO 60
          IF (X0 .GE. 7.5 .AND. R0 .GE. 4.2 .AND. R0 .LE. 5.0 .OR.
     1       X0 .GE. 8.5 .AND. R0 .GE. 4.2 .AND. R0 .LE. 6.0) GO TO 110
C     HAAO BCEH KOMEKCHO AMMA-YHK
             EPS = EPS1
             L = 1
             ARGR = 0.
             ARGI = R0
             CALL SF23C(ARGR,ARGI,U,V,EPS,L,IERR)
C     OKOHAHE BCEH KOEKCHO AMMA-YHK
             C0 = V/U
             T2 = ATAN(C0)
             IF (U .GE. 0 .AND. V .GE. 0 .OR. U .GE. 0 .AND. V .LE.
     1          0) GO TO 10
                IF (U .LT. 0 .AND. V .GE. 0) GO TO 20
                   IF (U .LT. 0 .AND. V .LT. 0) GO TO 30
   10              CONTINUE
                   T1 = T2
                   GO TO 40
   20        CONTINUE
             T1 = T2 + PI
             GO TO 40
   30  CONTINUE
       T1 = T2 - PI
   40  CONTINUE
       T = R0*ALOG(X0/2.) - T1
       C0 = SQRT(PI/(R0*(EXP(PI*R0) - EXP(-PI*R0))/2.))
       A1 = C0*COS(T)
       A2 = C0*SIN(T)
       A0 = R0*(X0/2.)**2/(1.+ R0**2)
       B0 = (X0/2.)**2/(1.+ R0**2)
       T0 = A1*(1.+ B0) + A2*A0
       DO 50 J = 1, 50
          F0 = (X0/2.)**2/((J + 1)**2 + R0**2)
          G0 = R0*(X0/2.)**2/((J + 1)*((J + 1)**2 + R0**2))
          H0 = A0
          A0 = A0*F0 + B0*G0
          B0 = B0*F0 - H0*G0
          T0 = T0 + A1*B0 + A2*A0
   50  CONTINUE
       GO TO 120
   60  CONTINUE
       DO 80 N = 2, 17
          C(1,N) = (-1)**N
          DO 70 M = 2, N
             C(M,N) = -C(M-1,N)*2*(N + M - 3)*(N - M + 1)/((M - 1)*
     1                (2*(M - 1)))
   70     CONTINUE
   80  CONTINUE
       C0 = R0**2 + 1./4.
       C1 = C0
       A(1) = 1/C0
       B(1) = 1/C0
       G(1) = 1/C0
       DO 90 M = 2, 17
          C2 = C1
          C1 = C0 + (M - 1)*M
          G(M) = G(M-1)*C2/(C1*X0)
          B(M) = -2.*(M - 1)*B(M-1)/C1
          A(M) = -2.*(M - 1)*A(M-1)/C1 + G(M)
   90  CONTINUE
       N = 17
       F0 = SQRT(PI/(2.*X0))*EXP(-X0)
       S1 = 0
       S2 = 0
       DO 100 M = 1, N
          S1 = S1 + C(M,N)*A(M)
          S2 = S2 + C(M,N)*B(M)
          T0 = F0*S1/S2
  100  CONTINUE
       GO TO 120
  110  CONTINUE
       A(1) = 0.
       B(1) = 5.
       FI = 0.
       E = EPS2
       L1 = 0
       L2 = 1
       CALL QSF3R(RINT1,RINT2,A,B,SF67R1,R0,FI,E,L1,L2)
       T0 = RINT2*EXP(-X0)
  120  CONTINUE
       T10 = T0
       CONTINUE
       RETURN
      END
